package 
{
	import flash.display.MovieClip;
	import mx.modules.IModuleInfo;
	import mx.events.ModuleEvent;
	import mx.modules.ModuleManager;
	import flash.events.Event;
	import mx.events.FlexEvent;
	import mx.modules.ModuleManager;
	import mx.core.IFlexModuleFactory;
	
	[SWF(width='500', height='500', backgroundColor='#FFFFFF', frameRate='30')]
	public class SimpleLoadingModuleExample extends MovieClip
	{
		private var mModuleInfo:IModuleInfo=null;

		public function SimpleLoadingModuleExample()
		{
			var moduleURL:String="MovieClipModule.swf";
			mModuleInfo=ModuleManager.getModule(moduleURL);
			mModuleInfo.addEventListener(FlexEvent.LOADING, onModuleLoading);
			mModuleInfo.addEventListener(ModuleEvent.SETUP, onModuleSetup);
			mModuleInfo.addEventListener(ModuleEvent.READY, onModuleReady);
			mModuleInfo.addEventListener(ModuleEvent.ERROR, onModuleError);
			mModuleInfo.addEventListener(ModuleEvent.PROGRESS, onModuleProgress);
			mModuleInfo.addEventListener(ModuleEvent.UNLOAD, onModuleUnload);
			mModuleInfo.load();
			//trace("loadModule "+moduleURL);
						
		}

		public function onModuleSetup(event:ModuleEvent):void
		{
			trace("onModuleSetup");
			
		}
				
		public function onModuleLoading(event:FlexEvent):void
		{
			trace("onModuleLoading");
			
		}
		
		public function onModuleReady(event:ModuleEvent):void
		{
			var moduleInfo:IModuleInfo=event.module;
			var factory:IFlexModuleFactory=event.module.factory;
			var module:MovieClipModule=factory.create() as MovieClipModule;
			addChild(module);
	
		}
		
		public function onModuleError(event:ModuleEvent):void
		{
			trace("onModuleError "+event.errorText);
			
		}

		public function onModuleProgress(event:ModuleEvent):void
		{
			trace("onModuleProgress "+event.bytesLoaded/event.bytesLoaded*100+"%");
		}

		public function onModuleUnload(event:ModuleEvent):void
		{
			trace("onModuleUnload");			
		}
	}
}
